package it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator;

/**
 * Interfaccia usata dal modello per mantenere
 * la UI coerente con lo stato della calcolatrice.
 *
 */
interface CalculatorUI {

  /** 
   * Imposta il risultato corrente della calcolatrice.
   * @param result il risultato della calcolatrice da visualizzare.
   */
  public void setValue(double result);
  
  /**
   * Abilita o disabilita l'introduzione di un operando
   * @param enabled se <code>true</code>, disabilita 
   */
  public void setDigits(boolean enabled);
  
  /**
   * Abilita o disabilita la possibilita' di richiedere il risultato di una operazione.
   * @param enabled Se <code>true</code>, abilita la richiesta di un risultato, altrimenti la disabilita.
   */
  public void setEquals(boolean enabled);

}
