package it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator;

/**
 * Rappresenta una operazione tra numeri decimali.
 */
public enum Operation {
  /**
   * Somma.
   */
  Sum, 
  /**
   * Differenza.
   */
  Diff, 
  /**
   * Moltiplicazione
   */
  Mult, 
  /**
   * Elevamento a potenza
   */
  Pow, 
  /**
   * Divisione
   */
  Div;

  /**
   * Esegue una operazione dati due parametri
   * @param a un parametro
   * @param b un parametro
   * @return il risultato dell'operazione applicata ai due parametri.
   */
  public double perform(double a, double b) {
	  switch (this) {
	  case Sum : return a + b;
	  case Diff: return a - b;
	  case Mult: return a * b;
	  case Div: return a / b;
	  case Pow : return Math.pow(a, b);
	  }
	  throw new RuntimeException("Unreachable statement");
  }

  /**
   * Restituisce una rappresentazione dell'operazione sotto forma
   * del carattere tipico utilizzato per rappresentarla.
   */
  @Override
  public String toString() {
	  switch(this) {
	  case Sum: return "+";
	  case Diff: return "-";
	  case Mult: return "*";
	  case Div: return "/";
	  case Pow: return "^";
	  }
	  throw new RuntimeException("Unreachable statement");
  }
 
}
